VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "File"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Type SHFILEINFO
    hIcon         As Long
    iIcon         As Long
    dwAttributes  As Long
    szDisplayName As String * MAX_PATH
    szTypeName    As String * 80
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

Private Declare Function OpenFile Lib "kernel32" (ByVal lpFileName As String, lpReOpenBuff As OFSTRUCT, ByVal wStyle As Long) As Long
Private Declare Function GetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function SetFileTime Lib "kernel32" (ByVal hFile As Long, lpCreationTime As FILETIME, lpLastAccessTime As FILETIME, lpLastWriteTime As FILETIME) As Long
Private Declare Function FileTimeToSystemTime Lib "kernel32" (lpFileTime As FILETIME, lpSystemTime As SYSTEMTIME) As Long
Private Declare Function SystemTimeToFileTime Lib "kernel32" (lpSystemTime As SYSTEMTIME, lpFileTime As FILETIME) As Long
Private Declare Function LocalFileTimeToFileTime Lib "kernel32.dll" (lpLocalFileTime As FILETIME, lpFileTime As FILETIME) As Long
Private Declare Function GetFileVersionInfo Lib "Version.dll" Alias "GetFileVersionInfoA" (ByVal lptstrFilename As String, ByVal dwhandle As Long, ByVal dwlen As Long, lpData As Any) As Long
Private Declare Function GetFileVersionInfoSize Lib "Version.dll" Alias "GetFileVersionInfoSizeA" (ByVal lptstrFilename As String, lpdwHandle As Long) As Long
Private Declare Function VerQueryValue Lib "Version.dll" Alias "VerQueryValueA" (pBlock As Any, ByVal lpSubBlock As String, lplpBuffer As Any, puLen As Long) As Long
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function SHGetFileInfo Lib "shell32" Alias "SHGetFileInfoA" (ByVal pszPath As Any, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
Private Declare Function ShellExecuteEx Lib "shell32.dll" (ShellExExInfo As SHELLEXECUTEINFO) As Long
Private Declare Function SHGetFileInfo2 Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath As String, ByVal dwFileAttributes As Long, psfi As SHFILEINFO, ByVal cbFileInfo As Long, ByVal uFlags As Long) As Long
Private Declare Function OleCreatePictureIndirect Lib "oleaut32.dll" (pDicDesc As IconType, riid As CLSIdType, ByVal fown As Long, lpUnk As Object) As Long
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function CreateShellLink Lib "vb6stkit.dll" Alias "fCreateShellLink" (ByVal lpstrFolderName As String, ByVal lpstrLinkName As String, ByVal lpstrLinkPath As String, ByVal lpstrLinkArguments As String, ByVal fPrivate As Long, ByVal sParent As String) As Long
Private Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
Private Declare Function ExtractFiles Lib "advpack.dll" (ByVal pszCabName As String, ByVal pszExpandDir As String, ByVal dwFlags As Long, ByVal pszFileList As String, lpReserved As Any, ByVal dwReserved As Long) As Long
Private Declare Function GetLongPathName Lib "kernel32.dll" Alias "GetLongPathNameA" (ByVal lpszShortPath As String, ByVal lpszLongPath As String, ByVal cchBuffer As Long) As Long
Private Declare Function EmptyClipboard Lib "user32" () As Long
Private Declare Function SetClipboardData Lib "user32" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function CloseClipboard Lib "user32" () As Long
Private Declare Function CreateHardLink Lib "kernel32.dll" Alias "CreateHardLinkA" (ByVal lpFileName As String, ByVal lpExistingFileName As String, ByRef lpSecurityAttributes As Long) As Long
Private Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function CreateFileB Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, lpSecurityAttributes As Any, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function DeviceIoControl Lib "kernel32" (ByVal hDevice As Long, ByVal dwIoControlCode As Long, lpInBuffer As Any, ByVal nInBufferSize As Long, lpOutBuffer As Any, ByVal nOutBufferSize As Long, lpBytesReturned As Long, lpOverlapped As Any) As Long
Private Declare Function SystemTimeToTzSpecificLocalTime Lib "kernel32.dll" (ByRef lpTimeZoneInformation As Long, ByRef lpUniversalTime As SYSTEMTIME, ByRef lpLocalTime As SYSTEMTIME) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, lpOverlapped As Any) As Long

Public Enum AttributeCompressedCommand
    acSelectCompressedAttribut = 0
    acDeselectCompressedAttribut = 1
End Enum

Public Type REGISTEREDFILETYPEINFO
    Prefix      As String
    Description As String
End Type

Public Type COMPILESDATEINFO
    cdDate As Date
    cdTime As Date
End Type

Public Type FILEATTRIBUTE
    Alias     As Boolean
    Archive   As Boolean
    Directory As Boolean
    Hidden    As Boolean
    Normal    As Boolean
    ReadOnly  As Boolean
    SYSTEM    As Boolean
    Volume    As Boolean
    
    FilePath  As String
End Type

Public Type FILETIMEINFO
    CREATED_DATE     As Date
    CREATED_TIME     As Date
    LASTACCESS_DATE  As Date
    LASTACCESS_TIME  As Date
    LASTCHANGED_DATE As Date
    LASTCHANGED_TIME As Date
End Type

Public Type EXTENDETFILEINFO
    COMPANYNAME      As String
    FILEDESCRIPTION  As String
    FILEVERSION      As String
    INTERNALNAME     As String
    LEGALCOPYRIGHT   As String
    ORIGINALFILENAME As String
    PRODUCTNAME      As String
    PRODUCTVERSION   As String
    COMMENTS         As String
    LEGALTRADEMARKS  As String
End Type

Public Type FILEHEADER
    Sign1       As Byte
    Sign2       As Byte
    FlenMod512  As Integer
    Flen512p    As Integer
    Nreloc      As Integer
    Hhdrsize16  As Integer
    Minrun      As Integer
    Maxrun      As Integer
    OffmoduleP  As Integer
    InStackpt   As Integer
    CheckSum    As Integer
    Entrypt     As Integer
    Offexe      As Integer
    Offexereloc As Integer
    Overlay     As Integer
End Type

Public Type FILEINFO
    Attributes       As FILEATTRIBUTE
    EXTENDET         As EXTENDETFILEINFO
    Time             As FILETIMEINFO
    HEADER           As FILEHEADER
    
    Path             As String
    SHORTPATH        As String
    LONGPATH         As String
    FileLen          As Long
    Directory        As String
    Owner            As String
End Type

Public Enum fOPERATION
    foCOPY = 1
    foMOVE = 2
    foRENAME = 3
    foDELETE = 4
End Enum

Public Type FOPEATION
    hwnd                As Long
    OPERATION           As OPERATION
    Source              As String
    Target              As String
    Confirm             As Boolean
    ShowProgress        As Boolean
    MOVETORECYCLEBIN    As Boolean
    SHOWDIALOGS         As Boolean
End Type

Public Enum ReadAs
    raDEC = 1
    raBIN = 2
    raHEX = 3
    raTEXT = 4
End Enum

Private Type SYSTEMTIME
    wYear         As Integer
    wMonth        As Integer
    wDayOfWeek    As Integer
    wDay          As Integer
    wHour         As Integer
    wMinute       As Integer
    wSecond       As Integer
    wMilliseconds As Integer
End Type


Public Type Binfile
    binData As String
End Type

Private Type VS_FIXEDFILEINFO
    dwSignature         As Long
    dwStrucVersionl     As Integer
    dwStrucVersionh     As Integer
    dwFileVersionMSl    As Integer
    dwFileVersionMSh    As Integer
    dwFileVersionLSl    As Integer
    dwFileVersionLSh    As Integer
    dwProductVersionMSl As Integer
    dwProductVersionMSh As Integer
    dwProductVersionLSl As Integer
    dwProductVersionLSh As Integer
    dwFileFlagsMask     As Long
    dwFileFlags         As Long
    dwFileOS            As Long
    dwFileType          As Long
    dwFileSubtype       As Long
    dwFileDateMS        As Long
    dwFileDateLS        As Long
End Type

Private Type SHELLEXECUTEINFO
    cbSize       As Long
    fMask        As Long
    hwnd         As Long
    lpVerb       As String
    lpFile       As String
    lpParameters As String
    lpDirectory  As String
    nShow        As Long
    hInstApp     As Long
    lpIDList     As Long
    lpClass      As String
    hkeyClass    As Long
    dwHotKey     As Long
    hIcon        As Long
    hProcess     As Long
End Type

Private Type IconType
    cbSize  As Long
    picType As PictureTypeConstants
    hIcon   As Long
End Type

Private Type CLSIdType
    ID(16) As Byte
End Type

Private Type OPENFILENAME
    lStructSize       As Long
    hWndOwner         As Long
    hInstance         As Long
    lpstrFilter       As String
    lpstrCustomFilter As String
    nMaxCustFilter    As Long
    nFilterIndex      As Long
    lpstrFile         As String
    nMaxFile          As Long
    lpstrFileTitle    As String
    nMaxFileTitle     As Long
    lpstrInitialDir   As String
    lpstrTitle        As String
    Flags             As Long
    nFileOffset       As Integer
    nFileExtension    As Integer
    lpstrDefExt       As String
    lCustData         As Long
    lpfnHook          As Long
    lpTemplateName    As String
End Type

Private Type udtFileInfo
    COMPANYNAME      As String
    FILEDESCRIPTION  As String
    FILEVERSION      As String
    INTERNALNAME     As String
    LEGALCOPYRIGHT   As String
    ORIGINALFILENAME As String
    PRODUCTNAME      As String
    PRODUCTVERSION   As String
    COMMENTS         As String
    LEGALTRADEMARKS  As String
End Type

Private Type PackFile
    Filename As String
    Contents As String
End Type

Private Type myPack
    FileS()     As PackFile
    UBoundFiles As Long
End Type

Private Const OF_READ = &H0&
Private Const OF_WRITE = &H1&

Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_HIDEREADONLY = &H4
Private Const OFN_PATHMUSTEXIST = &H800

Private Const OFS_MAXPATHNAME = 128&

Private Type OFSTRUCT
    cBytes     As Byte
    fFixedDisk As Byte
    nErrCode   As Integer
    Reserved1  As Integer
    Reserved2  As Integer
    szPathName(OFS_MAXPATHNAME) As Byte
End Type

Public Enum ShortcutNFO
    scAUTOSTART = 0
    scDESKTOP = 1
    scPROGRAMS = 2
    scFROMFILE = 3
    scSENDTO = 4
    scQUICKLAUNCH = 5
End Enum

Public Function Exist(ByVal File As String, Optional ErrorNumber As Long) As Boolean
    Dim FN As Integer

    On Local Error GoTo Quit
    
    ErrorNumber = 0
    FN = FreeFile
    
    Open File For Input As FN
    Close FN

    Exist = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Exist = False
    
    Err.Clear
    
End Function
Public Function Get_FileVersion(ByVal File As String) As String
    Dim Buff() As Byte
    Dim L As Long, BuffL As Long, Pointer As Long
    Dim Version As VS_FIXEDFILEINFO
 
    L = GetFileVersionInfoSize(File, 0&)
    If L < 1 Then Exit Function
    
    ReDim Buff(L)
      
    Call GetFileVersionInfo(File, 0&, L, Buff(0))
    Call VerQueryValue(Buff(0), "\", Pointer, BuffL)
    Call MoveMemory(Version, Pointer, Len(Version))
      
    Get_FileVersion = Format$(Version.dwFileVersionMSh) & "." & _
                      Format$(Version.dwFileVersionMSl) & "." & _
                      Format$(Version.dwFileVersionLSh) & "." & _
                      Format$(Version.dwFileVersionLSl)

End Function
Public Function TempFile_Create(Optional Directory As String) As String
    Dim Result As Long
    Dim Buff As String, Dir As String
            
    Dir = Directory
    
    If Dir = "" Then Dir = DLL.SYSTEM.SystemDirectory(sdUser_Temp)
        
    Buff = Space$(MAX_PATH)
    
    If GetTempFileName(Dir, "~", 0&, Buff) <> 0 Then
        Result = InStr(1, Buff, Chr$(0))
            
        If Result Then
            TempFile_Create = Buff
            TempFile_Create = Left$(Buff, Result - 1)
            TempFile_Create = Get_LongPath(TempFile_Create)
        End If
    End If
    
End Function
Public Function Get_LongPath(ByVal Path As String) As String
    Dim Result As Long
    Dim aa As String
    
    aa = Space$(255)
    Result = GetLongPathName(Path, aa, Len(aa))
    Get_LongPath = mID$(aa, 1, Result)

End Function
Public Function Get_ShortPath(ByVal Path As String) As String
    Dim Result As Long
    Dim aa As String
    
    aa = Space$(255)
    Result = GetShortPathName(Path, aa, Len(aa))
    Get_ShortPath = mID(aa, 1, Result)

End Function
Public Function Get_FileDescription(ByVal File As String) As String
    Dim L As Integer
    Dim SHInf As SHFILEINFO
  
    Call SHGetFileInfo(File, 0, SHInf, Len(SHInf), SHGFI_TYPENAME)
    
    L = InStr(1, SHInf.szTypeName, Chr$(0)) - 1
    Get_FileDescription = Left$(SHInf.szTypeName, L)
    
End Function
Public Function Show_FilePropertiesDialog(ByVal hwnd As Long, ByVal File As String) _
                                                As Boolean
    Dim SHInfo As SHELLEXECUTEINFO
    
    Const SEE_MASK_INVOKEIDLIST = &HC
    Const SEE_MASK_NOCLOSEPROCESS = &H40
    Const SEE_MASK_FLAG_NO_UI = &H400

    With SHInfo
        .cbSize = Len(SHInfo)
        .fMask = SEE_MASK_NOCLOSEPROCESS Or SEE_MASK_INVOKEIDLIST Or SEE_MASK_FLAG_NO_UI
        .hwnd = hwnd
        .lpVerb = "properties"
        .lpFile = File
        .lpIDList = 0
    End With

    Show_FilePropertiesDialog = ShellExecuteEx(SHInfo)
    
End Function
Public Function Get_LinkedIconFromFile(ByVal File As String, _
                                       Optional SmallIcon As Boolean = False) As IPictureDisp
    Dim Size As Long
    Dim Icon As IconType
    Dim clsid As CLSIdType
    Dim ShellInfo As SHFILEINFO
    
    Size = IIf(SmallIcon, &H101, &H100)
    
    Call SHGetFileInfo2(File, 0, ShellInfo, Len(ShellInfo), Size)
 
    Icon.cbSize = Len(Icon)
    Icon.picType = vbPicTypeIcon
    Icon.hIcon = ShellInfo.hIcon
    
    clsid.ID(8) = &HC0
    clsid.ID(15) = &H46
    
    Call OleCreatePictureIndirect(Icon, clsid, 1, Get_LinkedIconFromFile)
    
End Function
Public Function Show_FileDialogOpen(ByVal hwnd As Long, Optional Filter As String = "*.*", _
                                    Optional xPos As Long = -1, Optional yPos As Long = -1) _
                                            As String
    Dim Buffer As String
    Dim Flags As Long
    Dim ComDlgOpenFileName As OPENFILENAME
    Dim frm As New MyControls
  
    Flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
        
    Buffer = STRING$(128, 0)
   
    With ComDlgOpenFileName
        .lStructSize = Len(ComDlgOpenFileName)
        .hWndOwner = hwnd
        .Flags = Flags
        .nFilterIndex = 1
        .nMaxFile = Len(Buffer)
        .lpstrFile = Buffer
        .lpstrFilter = Filter
    End With
    
    If xPos > -1 Or yPos > -1 Then
        Load frm
        Call frm.SetMsgbox(hwnd, xPos, yPos)
        Set frm = Nothing
    End If
    
    If GetOpenFileName(ComDlgOpenFileName) Then
        Show_FileDialogOpen = Left$(ComDlgOpenFileName.lpstrFile, InStr(ComDlgOpenFileName.lpstrFile, Chr$(0)) - 1)
    End If
    
    Err.Clear
    
End Function
Public Function Show_FileDialogSave(ByVal hwnd As Long, _
                                    Optional Filter As String = "*.*", Optional Filename As String, _
                                    Optional xPos As Long = -1, Optional yPos As Long = -1) _
                                            As String
    Dim Buffer As String
    Dim ComDlgOpenFileName As OPENFILENAME
    Dim frm As New MyControls
    
    Buffer = Filename & STRING$(128 - Len(Filename), 0)
    
    With ComDlgOpenFileName
        .lStructSize = Len(ComDlgOpenFileName)
        .hWndOwner = hwnd
        .Flags = OFN_HIDEREADONLY Or OFN_PATHMUSTEXIST
        .nFilterIndex = 1
        .nMaxFile = Len(Buffer)
        .lpstrFile = Buffer
        .lpstrFilter = Filter
    End With

    If xPos > -1 Or yPos > -1 Then
        Load frm
        Call frm.SetMsgbox(hwnd, xPos, yPos)
        Set frm = Nothing
    End If
    
    If GetSaveFileName(ComDlgOpenFileName) Then
        Show_FileDialogSave = Left$(ComDlgOpenFileName.lpstrFile, InStr(ComDlgOpenFileName.lpstrFile, Chr$(0)) - 1)
    End If
    
End Function
Public Function Create_File(ByVal File As String) As Long
    Dim FN As Integer
        
    On Local Error GoTo Quit
    
    Call fKill(File)
    
    FN = FreeFile
    
    Open File For Output As FN
    Close FN

    Exit Function
    
Quit:
    Create_File = Err.Number

    Call ERROR(File_, "Create_File", Err.Number, Err.Description, File)

    Err.Clear

End Function
Public Function Get_FileLen(ByVal File As String, _
                            Optional ErrorNumber As Long) As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    Get_FileLen = FileLen(File)

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Get_FileLen = -2
    
    Call ERROR(File_, "Get_FileLen", Err.Number, Err.Description, File)

    Err.Clear
    
End Function
Public Function Find(ByVal FileToFind As String, ByVal StartSearchPath As String, _
                     Optional SearchAllDrives As Boolean = False, _
                     Optional ShowProgress As Boolean = False) As String
    Dim P As Long
    Dim sDrv As String, cDrv As String
    
    If StartSearchPath = "" And Not SearchAllDrives Then Exit Function
    If ShowProgress Then basPModule.LoadProgbar = True
    
    If SearchAllDrives Then
        sDrv = DLL.Drive.Get_AllDrives
                
        For P = 1 To Len(sDrv)
            cDrv = mID$(sDrv, P, 1) & ":\"
            Find = GetAllFiles(cDrv, FileToFind, False, ShowProgress)
            
            If Len(Find) Then Exit For
        Next P
    Else
        Find = GetAllFiles(StartSearchPath, FileToFind, False, ShowProgress)
    End If
    
    If ShowProgress Then
        Unload basPModule.PBar
        Set basPModule.PBar = Nothing
    End If
    
    Err.Clear

End Function
Public Function Compare(ByVal File1 As String, ByVal File2 As String, _
                        Optional ErrorNumber As Long) As Boolean
    Dim R1$, R2$
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If FileLen(File1) = FileLen(File2) Then
        R1$ = DLL.TEXT.TextFile_Read(File1, ErrorNumber)
        
        If ErrorNumber <> 0 Then
            Compare = False
            Exit Function
        End If
        
        R2$ = DLL.TEXT.TextFile_Read(File2, ErrorNumber)
        
        If ErrorNumber <> 0 Then
            Compare = False
            Exit Function
        End If
        
        Compare = (R1 = R2)
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(File_, "Compare", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function isInUse(ByVal Path As String, Optional ErrorNumber As Long) As Boolean
    Dim FN As Integer
  
    On Local Error Resume Next
    
    ErrorNumber = 0
    
    FN = FreeFile

    Open Path For Binary Access Write As #FN
    Close #FN
    
    isInUse = (Err.Number <> 0)
    
    ErrorNumber = Err.Number
    
    Err.Clear
    
End Function
Public Function ShredderFile(ByVal Path As String, _
                             Optional WriteLoop As Long = 3) As Long
    Dim A As String, B As String, Key As String
    Dim FN As Integer
    Dim L As Long, X As Long, P As Long
        
    On Local Error GoTo Quit
    
    L = FileLen(Path)
        
    If WriteLoop = 0 Then WriteLoop = 1
    If WriteLoop < 0 Then WriteLoop = WriteLoop * (-1)

    For P = 1 To WriteLoop
        Key = ""
            
        For X = 1 To 10
            A = CStr(DLL.MISC.Get_Randomize(0, 9))
            B = Chr$(DLL.MISC.Get_Randomize(Asc("A"), Asc("E")))
        
            Key = Key & A & B
        Next X
            
        FN = FreeFile

        Open Path For Binary As #FN
            For X = 1 To (L / 5)
                Put #FN, , Key
                Call FlushFileBuffers(1)
            Next X
        Close #FN
    Next P
   
    ShredderFile = fKill(Path)
   
    Exit Function
   
Quit:
    ShredderFile = Err.Number

    Call ERROR(File_, "ShredderFile", Err.Number, Err.Description, Path)

    Err.Clear
    
End Function
Public Function SFV_GetSFVFromFile(ByVal File As String) As String
     
     SFV_GetSFVFromFile = SFV(CVar(File))

End Function
Public Function SFV_Compare(ByVal File1 As String, ByVal File2 As String) As Boolean
    
    SFV_Compare = (SFV(File1) = SFV(File2))

End Function
Public Function SFV_Validate(ByVal File As String, SFVs As String) As Boolean
    
    SFV_Validate = (SFVs = SFV(File))

End Function
Public Function SFV_CreateSFVfile(ByVal File As Variant, SFVfile As String) As Boolean
    Dim H$, L$, A$
    Dim F() As Variant
    Dim P As Long
    
    If Not isArray(File) Then
        ReDim F(0)
        F(0) = File
    Else
        F = File
    End If
    
    H$ = "; Generated by MFDLL " & _
         App.Major & "." & App.Minor & "." & App.Revision & vbCrLf & _
         "; (Compatible: WIN-SFV32)" & vbCrLf & vbCrLf
         
    For P = 0 To UBound(F)
        L$ = Get_FileFromPath(F(P)) & " " & SFV(F(P)) & vbCrLf
        A$ = A$ & L$
    Next P
    
    A$ = H$ & A$
    
    SFV_CreateSFVfile = (DLL.TEXT.TextFile_WriteText(SFVfile, A$) = 0)
    
End Function
Public Function isEXERunning(ByVal EXENAME As String, _
                             Optional Path As Boolean = False) As Boolean
    Dim PI() As PROCESSINFO
    Dim Index As Long
    
    PI = DLL.SYSTEM.Get_ProcessList(Path)
    
    Index = ProcessFind(PI, EXENAME)
    If Index > -1 Then isEXERunning = True

End Function
Public Function Get_FileFromPath(ByVal Path As String) As String
    
    If Path = "" Then Exit Function
    If PathIsDirectory(Path) Then Exit Function
    
    If Right$(Path, 1) <> "\" Then
        Get_FileFromPath = mID$(Path, SplitPath(Path) + 1)
    End If
    
End Function
Public Function Get_DirectoryFromPath(ByVal Path As String, _
                                      Optional ErrorNumber As Long) As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If PathIsDirectory(Path) Then
        Get_DirectoryFromPath = Path
        Exit Function
    End If
    
    If Right$(Path, 1) = "\" Then
        Get_DirectoryFromPath = Path
    Else
        Get_DirectoryFromPath = GetDir(mID$(Path, 1, SplitPath(Path) - 1))
    End If
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    Get_DirectoryFromPath = ""

    Call ERROR(File_, "Get_DirectoryFromPath", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function FileOperation(OPERATION As FOPEATION) As Long
    
    With OPERATION
        FileOperation = SH_FileOperation(.hwnd, .OPERATION, .Source, .Target, False, _
                                         .Confirm, .SHOWDIALOGS, .ShowProgress, _
                                         .MOVETORECYCLEBIN)
   End With
   
End Function
Public Function Get_RootFromPath(ByVal Path As String) As String
    Dim X As Long
        
    X = InStr(Path, ":")
    If X = 0 Then Exit Function
    
    Get_RootFromPath = mID(Path, 1, X) & "\"
    
End Function
Private Function CalcFTime(FTime As SYSTEMTIME) As Date
    Dim Datum As String, Zeit As String
    Dim mm As String, SS As String, DT As Date
    Dim DA As String, Mo As String, Ye As String

    With FTime
        DA = .wDay
        If Len(DA) < 2 Then DA = "0" & DA
    
        Mo = .wMonth
        If Len(Mo) < 2 Then Mo = "0" & Mo
    
        Ye = CStr(.wYear)
        Datum = DA & "." & Mo & "." & Ye
    
        mm = Trim$(CStr(.wMinute))
        If Len(mm) < 2 Then mm = "0" & mm
    
        SS = Trim$(CStr(.wSecond))
        If Len(SS) < 2 Then SS = "0" & SS
    
        Zeit = .wHour & ":" & mm & ":" & SS
        DT = CDate(Datum & " " & Zeit)
        CalcFTime = DT
    End With

End Function
Public Function CABfile_Extract(ByVal CABFile As String, _
                                ByVal SourceFile As String, ByVal DestPath As String) _
                                        As Boolean
    
    If ExtractFiles(CABFile, DestPath, 0, SourceFile, 0, 0) = 0 Then
        CABfile_Extract = True
    End If
    
End Function
Public Function ShortCut_Create(Where As ShortcutNFO, SourceFile As String, _
                                TEXT As String, Optional TargetFile As String) As Long
    Dim Path As String, Str As String
    Dim fso As New FileSystemObject
    Dim WSH As New IWshShell_Class
    Dim SCut
    Dim X As Long
    
    On Local Error GoTo Quit
    
    Select Case Where
        Case scAUTOSTART
            Path = ".\Autostart"
        Case scDESKTOP
            Path = "..\..\Desktop"
        Case scPROGRAMS
            Path = "."
        Case scSENDTO, scQUICKLAUNCH
            Select Case Where
                Case scSENDTO
                    X = sdUser_SendTo
                Case scQUICKLAUNCH
                    X = sdUser_QuickLaunch
            End Select
            
            Path = DLL.SYSTEM.SystemDirectory(X)
            
            Str = GetBlankName(SourceFile) & ".lnk"
            Path = Path & Str
            
            ShortCut_Create = ShortCut_Create(scFROMFILE, SourceFile, TEXT, Path)
            
            Exit Function
        Case scFROMFILE
            If Not fso.FileExists(TargetFile) Then
                Set SCut = WSH.CreateShortcut(TargetFile)
                
                SCut.TargetPath = SourceFile
                SCut.Save
            End If
        
            Set SCut = Nothing
            Set fso = Nothing
            Set WSH = Nothing
            
            Exit Function
    End Select
    
    Call CreateShellLink(Path, TEXT, SourceFile, "", True, "$(Programs)")
    
    Exit Function
    
Quit:
    ShortCut_Create = Err.Number

    Call ERROR(File_, "ShortCut_Create", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function Split(ByVal File As String, ByVal KBperFile As Long, _
                      Optional OutputFile As String, _
                      Optional CreateBatch As Boolean = False) As Long
    Dim Zieln As String, Batch As String, R$
    Dim Max As Long, P As Long, i As Long, L As Long
    Dim Found As Boolean
        
    On Local Error GoTo Quit
  
    Max = KBperFile * 1024
    
    If Max < 1 Then Exit Function
    If Not Exist(File) Then Split = -1: _
                            Exit Function
  
    L = FileLen(File)
    If L < Max Then Split = -2: _
                    Exit Function
    
    If OutputFile <> vbNullString Then
        OutputFile = OutputFile & "."
    Else
        P = DLL.STRING.InStrRev(File, ".")
        Found = (P > 0)
        
        If Found Then
            OutputFile = mID$(File, 1, P)
        Else
            OutputFile = OutputFile & "."
        End If
    End If
        
    Batch = OutputFile & "Bat"
        
    R$ = ""
    
    Open File For Binary As 1
        R$ = R$ & "copy /b "
        i = 1
      
        For P = 0 To L Step Max
            Zieln = OutputFile & Format$(i, "000")
                   
            If Exist(Zieln) Then Kill Zieln
        
            Open Zieln For Binary As 3
                If L - P < Max Then
                    ByteCopy L - P, 1, 3
                Else
                    ByteCopy Max, 1, 3
                End If
            Close 3
    
            If i > 1 Then R$ = R$ & " + "
            R$ = R$ & Get_FileFromPath(Zieln)

            i = i + 1
        Next P
  
        R$ = R$ & " " & Get_FileFromPath(File)
    Close 1
    
    If CreateBatch Then
        If Not DLL.TEXT.TextFile_WriteText(Batch, R$) Then
            Split = -3
            Exit Function
        End If
    End If
    
    Split = 0
   
    Exit Function
    
Quit:
    Split = Err.Number

    Call ERROR(File_, "Split", Err.Number, Err.Description, File)

    Err.Clear
    
End Function
Private Sub ByteCopy(Bytes, Quelle, Ziel)
    Dim i As Long
    Dim Puffer() As Byte
  
    ReDim Puffer(1 To 32768)
  
    For i = 0 To Bytes - 1 Step 32768
        If Bytes - i < 32768 Then ReDim Puffer(1 To Bytes - i)
        Get Quelle, , Puffer
        Put Ziel, , Puffer
    Next i

End Sub
Public Function Join(ByVal StartFile As String, Optional OutputFile As String) As Long
    Dim L As Long, Max As Long, P As Long, i As Long
    Dim Source As String, R$
        
    On Local Error GoTo Quit
    
    If Not Exist(StartFile) Then
        Join = -1

        Exit Function
    End If
                                
    If Right$(StartFile, 4) <> ".001" Then
        Join = -2
                                         
        Exit Function
    End If
                                      
    If FileLen(StartFile) = 0 Then
        Join = -3
        
        Exit Function
    End If
    
    If OutputFile = vbNullString Then
        OutputFile = Left$(StartFile, Len(StartFile) - 3) & "out"
        R$ = Left$(StartFile, Len(StartFile) - 3)
    End If
    
    If Exist(OutputFile) Then Kill OutputFile

    If Not Exist(R$ & Format$(2, "000")) Then
        Join = -4
        
        Exit Function
    End If
    
    i = 1
    Max = 1024000
    
    Source = R$ & Format$(i, "000")
    
    Open OutputFile For Binary As 1
        Do While Exist(Source)
            Open Source For Binary As 3
                L = FileLen(Source)

                For P = 0 To L Step Max
                    If L - P < Max Then
                        ByteCopy L - P, 3, 1
                    Else
                        ByteCopy Max, 3, 1
                    End If
                    
                    DoEvents
                Next P
            Close 3
            
            i = i + 1
            Source = R$ & Format$(i, "000")
        Loop
    Close 1
    
    Join = 0
    
    Exit Function
    
Quit:
    Join = Err.Number
         
    Call ERROR(File_, "Join", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function Set_FileTime(ByVal File As String, FILETIME As FILETIMEINFO) As Long
    Dim fAttr As VbFileAttribute
    Dim hFile As Long
    Dim OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME

    On Local Error GoTo Quit
    
    fAttr = GetAttr(File)
    Call SetAttr(File, vbNormal)
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(File, OFS, OF_WRITE)

    If hFile > 0 Then
        With FILETIME
            cTime = CalcNewfTime(.CREATED_DATE & " " & .CREATED_TIME)
            lTime = CalcNewfTime(.LASTACCESS_DATE & " " & .LASTACCESS_TIME)
            lwTime = CalcNewfTime(.LASTCHANGED_DATE & " " & .LASTCHANGED_TIME)
        
            Call SetFileTime(hFile, cTime, lTime, lwTime)
            Call CloseHandle(hFile)
        End With
    Else
        Set_FileTime = -1
    End If

    On Local Error Resume Next
    Call SetAttr(File, fAttr)
    Err.Clear
    
    Exit Function
    
Quit:
    Set_FileTime = Err.Number
    Set_FileTime = -2

    Call ERROR(File_, "Set_FileTime", Err.Number, Err.Description, File)
    
    Err.Clear
    
End Function
Private Function CalcNewfTime(ByVal Datum As String) As FILETIME
    Dim SysT As SYSTEMTIME, ft As FILETIME
    Dim FTL As FILETIME
     
    With SysT
        .wDay = CInt(Left$(Datum, 2))
        .wMonth = CInt(mID$(Datum, 4, 2))
        .wYear = CInt(mID$(Datum, 7, 4))
        .wHour = CInt(mID$(Datum, 12, 2))
        .wMinute = CInt(mID$(Datum, 15, 2))
        .wSecond = CInt(mID$(Datum, 18, 2))
    End With
    
    Call SystemTimeToFileTime(SysT, ft)
    Call LocalFileTimeToFileTime(ft, FTL)
    
    CalcNewfTime = FTL

End Function
Public Function Get_FileTime(ByVal File As String) As FILETIMEINFO
    Dim DTformat As String, A() As String
    Dim T(2) As Date
    Dim hFile As Long
    Dim OFS As OFSTRUCT
    Dim cTime As FILETIME, lTime As FILETIME, lwTime As FILETIME
    Dim sTime As SYSTEMTIME
    
    OFS.cBytes = Len(OFS)
    hFile = OpenFile(File, OFS, OF_READ)
    
    If hFile > 0 Then
        DTformat = "dd.mm.yyyy hh:mm:ss"
        Call GetFileTime(hFile, cTime, lTime, lwTime)
        
        'Case tiCREATED
        Call FileTimeToSystemTime(cTime, sTime)
        T(0) = Format$(CalcFTime(sTime), DTformat)
        
        'Case tiLASTACCESS
        Call FileTimeToSystemTime(lTime, sTime)
        T(1) = Format$(CalcFTime(sTime), DTformat)
            
        'Case tiLASTCHANGED
        Call FileTimeToSystemTime(lwTime, sTime)
        T(2) = Format$(CalcFTime(sTime), DTformat)
            
        Call CloseHandle(hFile)
    
        With Get_FileTime
            A = VBA.Split(T(0), Chr$(32))
            .CREATED_DATE = A(0)
            .CREATED_TIME = A(1)
            
            A = VBA.Split(T(1), Chr$(32))
            .LASTACCESS_DATE = A(0)
            .LASTACCESS_TIME = A(1)
            
            A = VBA.Split(T(2), Chr$(32))
            .LASTCHANGED_DATE = A(0)
            .LASTCHANGED_TIME = A(1)
        End With
    End If
    
End Function
Public Function Binary_Read(ByVal File As String, _
                            ByVal ReadLenght As Long, ReadAs As ReadAs, _
                            Optional ByVal offset As Long = 1, _
                            Optional ErrorNumber As Long) As String()
    Dim A() As Byte, B() As Byte
    Dim P As Long, Max As Long, Count As Long, U As Long
    Dim Str() As Variant
    Dim FN As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    offset = offset - 1
    
    If ReadLenght Then
        ReadLenght = ReadLenght - 1
    Else
        ReadLenght = FileLen(File)
        offset = 1
    End If
    
    If offset + ReadLenght > FileLen(File) + 1 Then Exit Function
    
    ReDim A(ReadLenght)
    ReDim B(10000)
    
    Max = offset / 10000
    FN = FreeFile
    
    Open File For Binary As FN
        For P = 1 To Max
            Get FN, , B
        Next P
        
        If offset Then ReDim B((P - 1) * Max + offset): _
                       Get FN, , B
            
        Get FN, , A
    Close FN
    
    U = DLL.ARRAY.Get_UBound(B)
    If U > 0 Then ReDim Preserve A(UBound(A) - U - 2)
    
    Call DLL.ARRAY.AddArray(B, A, arTOEND)
    
    A = B
    
    ReDim Str(UBound(A))
    
    For P = 0 To UBound(A)
        Select Case ReadAs
            Case raBIN:  Str(P) = DLL.MATH.DecToBin(A(P))
                         Str(P) = STRING(8 - Len(Str(P)), "0") & Str(P)
            Case raDEC:  Str(P) = CStr(A(P))
                         
                         If Len(Str(P)) < 2 Then
                            Str(P) = STRING(2 - Len(Str(P)), "0") & Str(P)
                         End If
                         
            Case raHEX:  Str(P) = Hex(A(P))
                         Str(P) = STRING(2 - Len(Str(P)), "0") & Str(P)
            Case raTEXT: Str(P) = Chr$(A(P))
        End Select
        
        Count = Count + 1
        
        If Count > 1000 Then Count = 0: _
                             DoEvents
    Next P
    
    Binary_Read = DLL.ARRAY.ToString(Str)
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(File_, "Binary_Read", Err.Number, Err.Description, File)
    
    Err.Clear

End Function
Public Function BinCopy(ByVal SourceFile As String, ByVal TargetDirectory As String, _
                        Optional ShowProgress As Boolean = False, _
                        Optional ScrollColor As Long = vbBlue, _
                        Optional MessageText As String = "", _
                        Optional MessageTransparenz As Byte = 255) As Long
    Dim X As Long, Max As Long, L As Long, P As Long
    Dim Target As String, P1$, P2$
    Dim frm As New ProgBar
            
    On Local Error GoTo Quit
    
    TargetDirectory = GetDir(TargetDirectory)
        
    X = SplitPath(SourceFile)
    Target = TargetDirectory & mID$(SourceFile, X + 1)
    
    Call fKill(Target)
    
    Max = 1024000
    L = FileLen(SourceFile)

    If ShowProgress Then
        Load frm
        frm.Tag = "BinCopy"
        
        Call DLL.WINDOW.Set_Transparenz(frm.hwnd, MessageTransparenz)
        Call frm.SetOption(0, L, MessageText, True, ScrollColor)
    End If
        
    X = 0
        
    Open SourceFile For Binary As 3
    Open Target For Binary As 1

        For P = 0 To L Step Max
            If ShowProgress And P = 0 Then
                P1 = SourceFile
                P2 = Target
                
                P1 = DLL.CRTL.Control_CompactPath(frm.Message, P1)
                P2 = DLL.CRTL.Control_CompactPath(frm.Message, P2)
                
                P1 = P1 & vbCrLf & P2
                
                frm.Message.Caption = P1
                frm.Message.Refresh
            End If
            
            If L - P < Max Then
                X = X + (L - P)
                ByteCopy L - P, 3, 1
            Else
                X = X + Max
                ByteCopy Max, 3, 1
            End If
                
            If ShowProgress Then Call frm.SetValue(X, ScrollColor)
          
            DoEvents
        Next P

Quit:
    BinCopy = Err.Number

    If Err.Number <> 0 Then Call ERROR(File_, "BinCopy", Err.Number, Err.Description)

    Close 3
    Close 1
        
    If ShowProgress Then Unload frm
    Set frm = Nothing

    Err.Clear
    
End Function
Public Function fKill(ByVal File As String) As Long
    
    On Local Error Resume Next
    
    Call SetAttr(File, vbNormal)
    Err.Clear
        
    Call Kill(File)
    
    If Err.Number = 53 Then Err.Clear
    
    fKill = Err.Number
        
    Err.Clear
    
End Function
Public Function Get_PrefixFromPath(ByVal Path As String) As String
    Dim X As Long
    
    If Right$(Path, 1) = "." Then Exit Function
    
    X = DLL.STRING.InStrRev(Path, ".")
    
    If X > 0 Then Get_PrefixFromPath = Right$(Path, X)
    
End Function
Public Function Binary_Write(ByVal File As String, sByte() As Byte, _
                             Optional OverwriteExist As Boolean = False) As Long
    Dim FN As Integer
    
    On Local Error GoTo Quit
    
    If Not OverwriteExist Then _
        If Exist(File) Then Exit Function
    
    Call fKill(File)
    
    FN = FreeFile
    
    Open File For Binary As FN
        Put FN, , sByte
    Close FN
    
    Exit Function
    
Quit:
    Binary_Write = Err.Number

    Call ERROR(File_, "Binary_Write", Err.Number, Err.Description, File)

    Err.Clear
    
End Function
Public Function Get_ExtendedFileInfo(ByVal File As String) As EXTENDETFILEINFO
    Dim uInfo As udtFileInfo
    Dim DI As EXTENDETFILEINFO
    
    uInfo = GetExtendedFileInfo(File)

    With uInfo
        DI.COMPANYNAME = .COMPANYNAME
        DI.FILEDESCRIPTION = .FILEDESCRIPTION
        DI.FILEVERSION = .FILEVERSION
        DI.INTERNALNAME = .INTERNALNAME
        DI.LEGALCOPYRIGHT = .LEGALCOPYRIGHT
        DI.ORIGINALFILENAME = .ORIGINALFILENAME
        DI.PRODUCTNAME = .PRODUCTNAME
        DI.PRODUCTVERSION = .PRODUCTVERSION
        DI.COMMENTS = .COMMENTS
        DI.LEGALTRADEMARKS = .LEGALTRADEMARKS
    End With
    
    Get_ExtendedFileInfo = DI
    
End Function
Private Function GetExtendedFileInfo(ByVal sFile As String) As udtFileInfo
    Dim nSize As Long
    Dim sBuffer As String
    
    nSize = GetFileVersionInfoSize(sFile, 0&)
    
    If nSize = 0 Then Exit Function
  
    sBuffer = Space$(nSize)
  
    If GetFileVersionInfo(sFile, 0&, nSize, ByVal strptr(sBuffer)) = 0 Then Exit Function
  
    With GetExtendedFileInfo
        .COMMENTS = ExtractData(sBuffer, "Comments")
        .COMPANYNAME = ExtractData(sBuffer, "CompanyName")
        .FILEDESCRIPTION = ExtractData(sBuffer, "FileDescription")
        .FILEVERSION = ExtractData(sBuffer, "FileVersion")
        .INTERNALNAME = ExtractData(sBuffer, "InternalName")
        .LEGALCOPYRIGHT = ExtractData(sBuffer, "LegalCopyright")
        .LEGALTRADEMARKS = ExtractData(sBuffer, "Trademarks")
        .ORIGINALFILENAME = ExtractData(sBuffer, "OriginalFilename")
        .PRODUCTNAME = ExtractData(sBuffer, "ProductName")
        .PRODUCTVERSION = ExtractData(sBuffer, "ProductVersion")
    End With

End Function
Private Function ExtractData(ByVal sBuffer As String, ByVal sLookFor As String) As String
    Dim nPos As Long
    Dim sData As String
  
    nPos = InStr(sBuffer, Chr$(1) + sLookFor)
    
    If nPos > 0 Then
        sData = mID$(sBuffer, nPos + Len(sLookFor) + 2)
        If Left$(sData, 1) = vbNullChar Then sData = mID$(sData, 2)
        nPos = InStr(sData, vbNullChar)
        If nPos > 0 Then sData = Left$(sData, nPos - 1)
    End If
  
    ExtractData = sData

End Function
Public Function FilesToClipboard(FileList As Variant) As Boolean
    Dim sFiles As String
    Dim pTmp As Long, hTmp As Long, P As Long
    Dim F() As Variant
    Dim DROPFILES As DROPFILES
 
    If Not isArray(FileList) Then
        ReDim F(0)
        F(0) = FileList
    Else
        F = FileList
    End If
        
    For P = LBound(F) To UBound(F)
        sFiles = sFiles & F(P) & vbNullChar
    Next P
    
    sFiles = sFiles & vbNullChar
    
    If OpenClipboard(0&) Then
        EmptyClipboard
 
        hTmp = GlobalAlloc((GMEM_MOVEABLE Or GMEM_ZEROINIT), Len(DROPFILES) + Len(sFiles))
 
        If hTmp Then
            pTmp = GlobalLock(hTmp)
 
            DROPFILES.pFiles = Len(DROPFILES)
            
            Call CopyMemory(ByVal pTmp, DROPFILES, Len(DROPFILES))
            Call CopyMemory(ByVal (pTmp + Len(DROPFILES)), ByVal sFiles, Len(sFiles))
      
            Call GlobalUnlock(hTmp)
 
            If SetClipboardData(CF_HDROP, hTmp) Then FilesToClipboard = True
        End If
    End If

    Call CloseClipboard

End Function
Public Function ReadAsByte(ByVal File As String, _
                           Optional ErrorNumber As Long) As Byte()
    Dim FN As Integer
    Dim B() As Byte
    Dim L As Long
    Dim A As String
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    FN = FreeFile
    
    Open File For Binary As #FN
        A = Input(LOF(1), #FN)
    Close FN
    
    L = Len(A) - 1
    
    If L = -1 Then
        ErrorNumber = -1
        Exit Function
    End If
    
    ReDim B(0 To L)
    
    Call CopyMemory(B(0), ByVal A, L + 1)

    ReadAsByte = B

    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(File_, "ReadAsByte", Err.Number, Err.Description, File)
    
    Erase B
    ReadAsByte = B
    
    Err.Clear
    
End Function
Public Function SaveAsByte(ByRef B() As Byte, ByVal File As String, _
                           Optional OverwriteExist As Boolean = False, _
                           Optional ErrorNumber As Long) As Boolean
    Dim FN As Integer
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Exist(File) Then
        If Not OverwriteExist Then Exit Function
        Call fKill(File)
    End If
  
    FN = FreeFile
    
    Open File For Binary Access Write As #FN
        Put #FN, , B()
    Close #FN
    
    SaveAsByte = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    SaveAsByte = False
    
    Call ERROR(File_, "SaveAsByte", Err.Number, Err.Description, File)

    SaveAsByte = (Err.Number) = 0
    
End Function
Public Function RegisterExtension(ByVal AppName As String, ByVal AppPath As String, _
                                  ByVal AppReg As String, ByVal AppExt As String, _
                                  Optional IconFile As String = "", _
                                  Optional IconId As Long) As Boolean
    Dim lngKey As Long, lngResult As Long

    lngResult = RegCreateKey(HKEY_CLASSES_ROOT, AppReg, lngKey)
    lngResult = RegSetValue(lngKey, vbNullString, REG_SZ, AppName, 0)
    lngResult = RegCloseKey(lngKey)

    If Len(IconFile) > 0 Then
        lngResult = RegCreateKey(HKEY_CLASSES_ROOT, AppReg & "\DefaultIcon", lngKey)

        If Not IsMissing(IconId) Then IconFile = RTrim$(IconFile) & "," & IconId
        
        lngResult = RegSetValue(lngKey, vbNullString, REG_SZ, IconFile, 0)
        lngResult = RegCloseKey(lngKey)
    End If

    lngResult = RegCreateKey(HKEY_CLASSES_ROOT, "." & AppExt, lngKey)
    lngResult = RegSetValue(lngKey, vbNullString, REG_SZ, AppReg, 0)
    lngResult = RegCloseKey(lngKey)

    lngResult = RegCreateKey(HKEY_CLASSES_ROOT, AppReg, lngKey)
    lngResult = RegSetValue(lngKey, "shell\open\command", REG_SZ, AppPath & " %1", MAX_PATH)
    lngResult = RegCloseKey(lngKey)

    RegisterExtension = True
    
End Function
Public Function Has_Attribut(ByVal Path As String, Attribut As VbFileAttribute, _
                             Optional ErrorNumber As Long) As Boolean
            
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If GetAttr(Path) And Attribut Then Has_Attribut = True
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    If Err.Number <> 0 Then Call ERROR(File_, "Has_Attribut", Err.Number, Err.Description, Path)

    Err.Clear
    
End Function
Public Function Set_Attributes(ByVal Path As String, _
                               Attribut As VbFileAttribute, _
                               Optional ErrorNumber As Long) As Boolean
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    Call SetAttr(Path, Attribut)
    Set_Attributes = True

    Exit Function

Quit:
    ErrorNumber = Err.Number

    Call ERROR(File_, "Set_Attributes", Err.Number, Err.Description, Path)
    
    Err.Clear
    
End Function
Public Function Get_Attributes(ByVal File As String, _
                               Optional ErrorNumber As Long) As FILEATTRIBUTE
    Dim Fa As FILEATTRIBUTE
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    With Fa
        .Alias = GetAttr(File) And vbAlias
        .Archive = GetAttr(File) And vbArchive
        .Directory = GetAttr(File) And vbDirectory
        .Hidden = GetAttr(File) And vbHidden
        .Normal = GetAttr(File) And vbNormal
        .ReadOnly = GetAttr(File) And vbReadOnly
        .SYSTEM = GetAttr(File) And vbSystem
        .Volume = GetAttr(File) And vbVolume
    
        .FilePath = File
    End With
    
    Get_Attributes = Fa
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
     Call ERROR(File_, "Get_Attributes", Err.Number, Err.Description)

    Err.Clear
    
End Function
Public Function BrowseForFile(BROWSEINFO As BROWSENFO) As String
    
    BROWSEINFO.Flags = BROWSEINFO.Flags Or BIF_BROWSEINCLUDEFILES Or BIF_USENEWUI
    
    BrowseForFile = ShellBrowseForFolder(BROWSEINFO)
    
End Function
Public Function Get_Header(ByVal File As String, Optional ErrorNumber As Long) _
                                    As FILEHEADER
    Dim EXE2head As FILEHEADER
    Dim F As Long
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    F = FreeFile
    
    Open File For Binary Access Read As #F
        Get #F, , EXE2head '28 byte
    Close #F

    Get_Header = EXE2head

    Exit Function
    
Quit:
    ErrorNumber = Err.Number

    Call ERROR(File_, "Get_Header", Err.Number, Err.Description, File)
    
    Err.Clear
    
End Function
Public Function Get_FileInfo(ByVal File As String, _
                             Optional ErrorNumber As Long) As FILEINFO
    Dim FI As FILEINFO
    
    On Local Error GoTo Quit
    
    If Not Exist(File, ErrorNumber) Then Exit Function
    
    With FI
        .Path = File
        
        .SHORTPATH = DLL.File.Get_ShortPath(File)
        .LONGPATH = DLL.File.Get_LongPath(File)
        .Directory = DLL.File.Get_DirectoryFromPath(File)
        .EXTENDET = DLL.File.Get_ExtendedFileInfo(File)
        .Attributes = DLL.File.Get_Attributes(File)
        .HEADER = DLL.File.Get_Header(File)
        .Time = DLL.File.Get_FileTime(File)
        .FileLen = DLL.File.Get_FileLen(File)
        .Owner = DLL.Directory.Get_Owner(File)
    End With
    
    Get_FileInfo = FI
    
    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    If Err.Number <> 0 Then Call ERROR(File_, "Get_FileInfo", Err.Number, Err.Description)

    Err.Clear

End Function
Public Function Get_Owner(ByVal File As String) As String
    Get_Owner = DLL.Directory.Get_Owner(File)
End Function
Public Function OpenInExplorer(ByVal File As String, _
                               Optional ErrorNumber As Long) As Boolean
    Dim Param As String
    
    If Not Exist(File, ErrorNumber) Then Exit Function
    
    Param = "/select," & File
    
    OpenInExplorer = DLL.SHELL.Execute("Explorer.exe", Param)
    
End Function
Public Function Rename(ByVal File As String, ByVal NewName As String, _
                       Optional DeleteExist As Boolean = False) As Long
    Dim Directory As String
    Dim X As Long
    
    On Local Error GoTo Quit
    
    If Not Exist(File) Then Exit Function
    
    If InStr(NewName, "\") = 0 Then
        X = DLL.STRING.InStr(File, "\", itLast, False)
        
        If X > -1 Then Directory = mID(File, 1, X): _
                       NewName = Directory & NewName
    End If
    
    If (Not DeleteExist) Then
        If Exist(NewName) Then Exit Function
    Else
        Call fKill(NewName)
    End If
    
    Name File As NewName
    
    Exit Function
    
Quit:
    Rename = Err.Number
    
    Call ERROR(File_, "Rename", Err.Number, Err.Description, File & " -> " & NewName)

    Err.Clear

End Function
Public Function Get_Path(ByVal File As String, _
                         Optional ErrorNumber As Long) As String
    Dim X As Long
    
    If Not Exist(File, ErrorNumber) Then Exit Function
    
    X = DLL.STRING.InStr(File, "\", itLast)
    
    Get_Path = mID(File, 1, X)
    
End Function
Public Function Hardlink_Create(ByVal SourceFile As String, _
                                ByVal TargetFile As String) As Long
    Dim Result As Long
    
    If Not Exist(SourceFile) Then
        Hardlink_Create = -1
        Exit Function
    End If
    
    If Exist(TargetFile) Then
        Hardlink_Create = -2
        Exit Function
    End If
    
    Result = CreateHardLink(TargetFile, SourceFile, ByVal 0&)
    
    If Result <> 0 Then
        Hardlink_Create = 0
    Else
        Hardlink_Create = -3
    End If
    
End Function
Public Function Set_AttributeCompressed(ByVal File As String, _
                                        Command As AttributeCompressedCommand, _
                                        Optional ErrorNumber As Long) As Boolean
    Dim FSCTL_SET_COMPRESSION As Long, lngFileHandle As Long, lngCompression As Long, lngBytesReturned As Long, lngResult As Long
    Dim tagSECURITY_ATTRIBUTES As SECURITY_ATTRIBUTES
    
    Const FILE_DEVICE_FILE_SYSTEM = &H9
    Const METHOD_BUFFERED = 0
    Const FILE_READ_DATA = &H1
    Const FILE_WRITE_DATA = &H2
    Const COMPRESSION_FORMAT_NONE = &H0
    Const COMPRESSION_FORMAT_DEFAULT = &H1

    If Not Exist(File, ErrorNumber) Then Exit Function

    FSCTL_SET_COMPRESSION = CTL_CODE(FILE_DEVICE_FILE_SYSTEM, 16, _
                                     METHOD_BUFFERED, FILE_READ_DATA Or FILE_WRITE_DATA)
    tagSECURITY_ATTRIBUTES.nLength = Len(tagSECURITY_ATTRIBUTES)
    
    lngFileHandle = CreateFile(File, GENERIC_READ Or GENERIC_WRITE, 0, _
                               tagSECURITY_ATTRIBUTES, OPEN_EXISTING, 0, 0)
    
    If (lngFileHandle = INVALID_HANDLE_VALUE) Then Exit Function
    
    Select Case Command
        Case acDeselectCompressedAttribut: lngCompression = COMPRESSION_FORMAT_NONE
        Case acSelectCompressedAttribut:   lngCompression = COMPRESSION_FORMAT_DEFAULT
    End Select
    
    lngResult = DeviceIoControl(lngFileHandle, FSCTL_SET_COMPRESSION, lngCompression, _
                                Len(lngCompression), ByVal 0&, 0, lngBytesReturned, _
                                ByVal 0&)
    
    If (lngResult <> 0) Then Set_AttributeCompressed = True
    
    Call CloseHandle(lngFileHandle)
    
End Function
Private Function CTL_CODE(lngDeviceType, lngFunction, lngMethod, lngAccess) As Long
    CTL_CODE = ((lngDeviceType * (2 ^ 16)) Or (lngAccess * (2 ^ 14)) Or (lngFunction * (2 ^ 2)) Or lngMethod)
End Function
Public Function Archive_Extract(ByVal ArchiveFile As String, _
                                ByVal TargetPath As String) As Long
    Dim i As Long, FN As Long, UBF As Long
    Dim Pack As myPack
    
    FN = FreeFile
    
    Open ArchiveFile For Binary As #FN
        Get #FN, LOF(FN) - 3, UBF
    Close #FN
    
    ReDim Pack.FileS(UBF)
    
    Open ArchiveFile For Binary As #FN
        Get #FN, , Pack
    Close #FN
    
    TargetPath = GetDir(TargetPath)
    
    For i = 0 To UBF
        FN = FreeFile
        
        Open TargetPath & GetFileName(Pack.FileS(i).Filename) For Binary As #FN                             ' ffnen/erstellen,
            Put #FN, , Pack.FileS(i).Contents
        Close #FN
    Next i
    
    Exit Function
    
Quit:
    Archive_Extract = Err.Number
    
    Call ERROR(File_, "Archive_Extract", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Private Function GetFileName(xFile As String) As String
    Dim lastbs As Long
    
    lastbs = InStrRev(xFile, "\")
    GetFileName = mID(xFile, lastbs + 1)

End Function
Public Function Archive_Pack(FileS() As String, TargetArchive As String) As Long
    Dim i As Long
    Dim FN As Integer
    Dim zw As String
    Dim Pack As myPack
    
    On Local Error GoTo Quit
    
    Pack.UBoundFiles = UBound(FileS)
    
    ReDim Pack.FileS(Pack.UBoundFiles)
    
    For i = 0 To UBound(FileS())
        FN = FreeFile
        Open FileS(i) For Binary As #FN
        
        zw = Space(LOF(FN))
        Get #FN, , zw
        Pack.FileS(i).Contents = zw
        Pack.FileS(i).Filename = FileS(i)
        
        Close #FN
    Next i
    
    FN = FreeFile
    
    Open TargetArchive For Binary As #FN
        Put #FN, , Pack
    Close #FN

    Exit Function

Quit:
    Archive_Pack = Err.Number
    
    Call ERROR(File_, "Archiv_Write", Err.Number, Err.Description)
    
    Close #FN
    
    Err.Clear
    
End Function
Public Function Get_CompileTime(ByVal File As String, _
                                Optional ErrorNumber As Long) As COMPILESDATEINFO
    Dim strContent As String, strBuffer As String, strOffset As String
    Dim lngSeconds As Long, i As Long
    Dim FNr As Integer
    Dim dtFileTime As Date, D As Date, T As Date
    Dim tUniversalTime As SYSTEMTIME
    Dim tNewTime As SYSTEMTIME
    
    On Local Error GoTo Quit
    
    ErrorNumber = 0
    
    If Not Exist(File) Then Exit Function
    
    FNr = FreeFile
    
    Open File For Binary As #FNr
        strContent = Space(512)
        Get #FNr, , strContent
    Close #FNr
    
    strBuffer = Space(Len(strContent) * 2)
    
    For i = 0 To Len(strContent) - 1
        Mid(strBuffer, i * 2 + 1) = Right("00" & Hex$(Asc(mID(strContent, i + 1, 1))), 2)
    Next i
    
    i = InStr(strBuffer, "5045")
    If i = 0 Then Exit Function
        
    strOffset = mID$(strBuffer, i + 16, 8)
    strContent = mID$(strOffset, 7, 2) & mID$(strOffset, 5, 2) & mID$(strOffset, 3, 2) & mID$(strOffset, 1, 2)
    lngSeconds = CLng("&H" & strContent)
    dtFileTime = DateAdd("s", lngSeconds, CDate("01.01.1970"))
    
    tUniversalTime.wDayOfWeek = 1
    tUniversalTime.wYear = Year(dtFileTime)
    tUniversalTime.wMonth = Month(dtFileTime)
    tUniversalTime.wDay = Day(dtFileTime)
    tUniversalTime.wHour = Hour(dtFileTime)
    tUniversalTime.wMinute = Minute(dtFileTime)
    tUniversalTime.wSecond = Second(dtFileTime)
    
    SystemTimeToTzSpecificLocalTime ByVal 0&, tUniversalTime, tNewTime
    
    D = CDate(tNewTime.wDay & "." & tNewTime.wMonth & "." & tNewTime.wYear)
    T = CDate(tNewTime.wHour & ":" & tNewTime.wMinute & ":" & tNewTime.wSecond)

    D = Format(D, "dd.mm.yyyy")
    T = Format(T, "hh:mm:ss")

    Get_CompileTime.cdDate = D
    Get_CompileTime.cdTime = T

    Exit Function
    
Quit:
    ErrorNumber = Err.Number
    
    Call ERROR(File_, "Get_CompileTime", Err.Number, Err.Description)
    
    Err.Clear
    
End Function
Public Function MOVETORECYCLEBIN(File As String, _
                                 Optional Confirm As Boolean = False) As Boolean
    Dim SHFileOp As SHFILEOPSTRUCT
    Dim F As Long

    F = FOF_ALLOWUNDO
    If Confirm = False Then F = F + FOF_NOCONFIRMATION

    With SHFileOp
        .wFunc = FO_DELETE
        .pFrom = File
        .fFlags = F
    End With

    MOVETORECYCLEBIN = (SHFileOperation(SHFileOp) = 0)

End Function
Public Function Get_RegisteredFileTypes() As REGISTEREDFILETYPEINFO()
   Dim lCtr As Long, Count As Long
   Dim sSubkey As String * MAX_PATH, sClass As String * MAX_PATH, sTypeName As String
   Dim ft As FILETIME
   Dim RFT() As REGISTEREDFILETYPEINFO
   
   Const vbAscDot = 46
   
   lCtr = -1
   Count = 0
   
   Do
      lCtr = lCtr + 1
      
      If RegEnumKeyEx(HKEY_CLASSES_ROOT, lCtr, sSubkey, MAX_PATH, 0, sClass, MAX_PATH, ft) = ERROR_SUCCESS Then
         If Asc(sSubkey) = vbAscDot Then
            sTypeName = GetFileTypeName(sSubkey)
            
            If Len(sTypeName) Then
                ReDim Preserve RFT(Count)
                
                RFT(Count).Description = sTypeName
                RFT(Count).Prefix = Trim(GetStrFromBufferA(sSubkey))
            
                Count = Count + 1
            End If
         End If
      Else
         Exit Do
      End If
   Loop
   
   Get_RegisteredFileTypes = RFT
   
End Function
Private Function GetFileTypeName(sFile As String) As String
    Dim SHInfo As SHFILEINFO
   
    Const SHGFI_USEFILEATTRIBUTES = &H10
   
    If SHGetFileInfo(sFile, 0, SHInfo, Len(SHInfo), SHGFI_TYPENAME Or SHGFI_USEFILEATTRIBUTES) Then
        GetFileTypeName = GetStrFromBufferA(SHInfo.szTypeName)
    End If
   
End Function
Private Function GetStrFromBufferA(sz As String) As String
    
    If InStr(sz, vbNullChar) Then
        GetStrFromBufferA = Left$(sz, InStr(sz, vbNullChar) - 1)
    Else
        GetStrFromBufferA = sz
    End If

End Function
Public Function FileType_IsRegistered(ByVal Prefix As String) As Boolean
    Dim RFT() As REGISTEREDFILETYPEINFO
    Dim P As Long
    Dim R$
    
    If Left$(Prefix, 1) <> "." Then Prefix = "." & Prefix
    
    Prefix = LCase$(Prefix)
    
    RFT = Get_RegisteredFileTypes()
    
    If DLL.ARRAY.isDIM(RFT) Then
        For P = 0 To UBound(RFT)
            R$ = LCase$(RFT(P).Prefix)
            
            If R$ = Prefix Then
                FileType_IsRegistered = True
                Exit Function
            End If
        Next P
    End If
    
    FileType_IsRegistered = False
    
End Function
Public Function Get_FileTypeDescription(ByVal File As String) As String
    Dim Ext As String, R$
    Dim P As Long
    Dim RFT() As REGISTEREDFILETYPEINFO
    
    Ext = DLL.File.Get_PrefixFromPath(File)
    Ext = LCase$(Ext)
    RFT = Get_RegisteredFileTypes()
    
    If DLL.ARRAY.isDIM(RFT) Then
        For P = 0 To UBound(RFT)
            R$ = LCase$(RFT(P).Prefix)
            
            If R$ = Ext Then
                Get_FileTypeDescription = RFT(P).Description
                Exit Function
            End If
        Next P
    End If

End Function
Public Sub MSI_Extract(ByVal MSIfile As String, _
                            ByVal OutputDirectory As String)
    Dim cmd As String
                            
    Call DLL.Directory.CreatePath(OutputDirectory)
    
    cmd = "msiexec /a " & MSIfile & " /qb TARGETDIR=" & OutputDirectory
    
    Call DLL.SHELL.ExecuteAndWait(cmd, vbNormalFocus)

End Sub
Public Function ShortCut_GetTarget(File As String) As String
    Dim hFile As Long, DWord As Long, tmpPlace As Long, i As Long
    Dim tmpbyte As Byte
    Dim tmpint As Integer
    Dim Ret As Variant
    
    Const FILE_BEGIN = 0
    Const FILE_CURRENT = 1
    
    hFile = CreateFileB(File, ByVal (GENERIC_READ Or GENERIC_WRITE), FILE_SHARE_READ, ByVal 0&, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, ByVal 0)
    
    ReDim basebytes(75)
    
    If hFile <> INVALID_HANDLE_VALUE Then
        Call SetFilePointer(hFile, &H4C, 0, FILE_BEGIN)
        Call ReadFile(hFile, tmpint, 2, Ret, ByVal 0&)

        tmpPlace = CLng(tmpint + &H10)
        Ret = SetFilePointer(hFile, tmpPlace, 0, FILE_CURRENT)
        
        Call ReadFile(hFile, DWord, 4, Ret, ByVal 0&)
        Call SetFilePointer(hFile, &H4E + tmpint + DWord, 0, FILE_BEGIN)
        
        i = 0
        
        Do
            Call ReadFile(hFile, tmpbyte, 1, Ret, ByVal 0&)
            
            If tmpbyte = &H0 Then Exit Do
            
            ShortCut_GetTarget = ShortCut_GetTarget & Chr(tmpbyte)
            
            i = i + 1
        Loop Until tmpbyte = &H0
    End If
    
    CloseHandle hFile

End Function
